<template>
  <q-page padding class="row justify-center items-center">
    <q-card class="d-login">
      <q-card-section>
        <div class="row items-center no-wrap">
          <div class="col">
            <div class="text-h6">Iniciar Sesión</div>
          </div>
          <div class="col">
            <div class="text-right">
              <router-link :to="{ name: 'auth.register.business' }">
                Crear cuenta
              </router-link>
            </div>
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <q-form ref="login" class="q-gutter-md" @submit="onSubmit" @reset="onReset">
          <q-input
            outlined
            bottom-slots
            dense
            label="Correo electrónico *"
            type="email"
            :rules="[val => !!val || 'Campo es requerido.']"
            v-model.trim="data.username"
          />
          <q-input
            outlined
            bottom-slots
            dense
            label="Contraseña *"
            :type="isPwd?'password':'text'"
            :rules="[val => !!val || 'Campo es requerido.']"
            v-model.trim="data.password"
          >
            <template v-slot:append>
              <q-icon
                :name="isPwd?'visibility_off':'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>
          <q-card-actions>
            <q-btn flat label="Limpiar" type="reset" color="primary" class="q-ml-sm" />
            <q-btn label="Ingresar" type="submit" color="primary" :loading="isLoading" :disable="isLoading">
              <template v-slot:loading>
                <q-spinner-gears color="white" />
              </template>
            </q-btn>
          </q-card-actions>
        </q-form>
      </q-card-section>
    </q-card>
    <vue-recaptcha
      ref="recaptcha"
      size="invisible"
      :sitekey="siteKey"
      :loadRecaptchaScript="true"
      @verify="onCaptchaVerified"
      @expired="onCaptchaExpired"
    />
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
import VueRecaptcha from 'vue-recaptcha'

export default {
  name: 'Login',
  components: {
    VueRecaptcha
  },
  data () {
    return {
      data: {
        username: null,
        password: null
      },
      isPwd: true,
      siteKey: process.env.SITE_KEY,
      isLoading: false
    }
  },
  computed: {
    ...mapGetters({
      type: 'auth/type'
    })
  },
  methods: {
    onSubmit () {
      this.isLoading = true
      this.$refs.recaptcha.execute()
    },
    getRoute () {
      switch (this.type) {
        case 'Business':
          this.$router.push({ name: 'business.index' })
          break
        case 'Admin':
          this.$router.push({ name: 'admin.index' })
          break
      }
    },
    onReset () {
      this.data.username = null
      this.data.password = null
      this.data.isPwd = true
      this.onCaptchaExpired()
    },
    async onCaptchaVerified (recaptchaToken = '') {
      const process = await this.$refs.login.validate()
      if (process) {
        try {
          this.isLoading = true
          const { username, password } = this.data
          await this.$store.dispatch('auth/login', { username, password, recaptchaToken })
          this.getRoute()
        } catch (err) {
          this.$q.notify({
            position: 'top',
            message: err.message,
            color: 'negative',
            icon: 'sentiment_dissatisfied'
          })
          this.onCaptchaExpired()
        } finally {
          this.isLoading = false
        }
      }
    },
    onCaptchaExpired () {
      this.$refs.recaptcha.reset()
    }
  }
}
</script>
